package com.sundata.example.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.sundata.admin.nounmanage.model.DictContent;
import com.sundata.common.base.BaseMapper;
import com.sundata.example.model.ExampleSysRoleModel;
import com.sundata.example.model.ExampleSysUserModel;
/**
 * 用户处理示例Mapper
 * @author Administrator
 *
 * @param <T>
 */
public interface ExampleSysUserMapper<T> extends BaseMapper<T> {
	
	/**
	 * 更新用户信息
	 * @param tmp
	 * @return  修改记录数 
	 */
	
	public int updateNotEmptyByloginname(ExampleSysUserModel tmp);
	
	
	/**
	 * 获取机构信息
	 * @param loginname用户编号
	 * @param orgcode机构编号
	 * @return机构信息
	 */
	public List<DictContent> queryManyOrg(@Param("loginname")String loginname,@Param("orgcode")String orgcode);
  /**
   * 获取用户信息
   * @param model
   * @return  用户信息 
   */
	public List<ExampleSysUserModel> queryByloginname(ExampleSysUserModel model);
	
	/**
	 * 按条件更新
	 * @param t 更新条件及数据
	 * @return 修改记录数
	 */
	public int updateByLoginname(T t);
	/**
	 * 查询该用户 可以设置的岗位 
	 * 查询当前及直接间接上级机构的角色,当前机构级别在 岗位的最低级别和最高级别 之间 
	 * @param account
	 * @param orgcode
	 * @return
	 */
	public List<ExampleSysRoleModel>  getUserDataList(String account,String orgcode);
	
}
