package com.sundata.internalevaluation.configuration.controller;

import com.sundata.internalevaluation.configuration.model.DataSourcesModel;
import com.sundata.internalevaluation.configuration.model.ModelConfigModel;
import com.sundata.internalevaluation.configuration.service.ModelConfigService;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/internalevaluation/configuration/ModelConfigAction")
public class ModelConfigAction {

    @Autowired
    ModelConfigService modelConfigService;

    /**
     * @author: 张艳杰
     * @methodsName: getDataList
     * @description: 模型配置初始化
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody ModelConfigModel model
     * @return: List<ModelConfigModel>
     * @throws:
     */
    @RequestMapping({"getDataList"})
    public List<ModelConfigModel> getDataList(HttpServletRequest request, HttpServletResponse response,
                                              @RequestBody ModelConfigModel model) {
        return modelConfigService.getDataList(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: createData
     * @description: 模型配置新增
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody ModelConfigModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"createData"})
    public void createData(HttpServletRequest request, HttpServletResponse response,
                           @RequestBody ModelConfigModel model) {
        modelConfigService.createData(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: deleteRows
     * @description: 模型配置删除
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody ModelConfigModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"deleteRows"})
    public void deleteRows(HttpServletRequest request, HttpServletResponse response,
                           @RequestBody ModelConfigModel model) {
        modelConfigService.deleteRows(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: updateExistData
     * @description: 模型配置修改
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody ModelConfigModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"updateExistData"})
    public void updateExistData(HttpServletRequest request, HttpServletResponse response,
                                @RequestBody ModelConfigModel model) {
        modelConfigService.updateExistData(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: selectDetailData
     * @description: 模型配置查询
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody ModelConfigModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"selectDetailData"})
    public ModelConfigModel selectDetailData(HttpServletRequest request, HttpServletResponse response,
                                             @RequestBody ModelConfigModel model) {
        return modelConfigService.selectDetailData(model);
    }
}
