package com.sundata.internalevaluation.configuration.mapper;

import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import com.sundata.internalevaluation.configuration.model.SysInterfaceParam;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface SysInterfaceParamMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<SysInterfaceParam> listAll();


	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	SysInterfaceParam getById(String id);
	
	/**
     * 新增，插入所有字段
     *
     * @param SysInterfaceParam 新增的记录
     * @return 返回影响行数
     */
	int insert(SysInterfaceParam sysInterfaceParam);
	
	/**
     * 新增，忽略null字段
     *
     * @param SysInterfaceParam 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(SysInterfaceParam sysInterfaceParam);
	
	/**
     * 修改，修改所有字段
     *
     * @param SysInterfaceParam 修改的记录
     * @return 返回影响行数
     */
	int update(SysInterfaceParam sysInterfaceParam);
	
	/**
     * 修改，忽略null字段
     *
     * @param SysInterfaceParam 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(SysInterfaceParam sysInterfaceParam);
	
	/**
     * 删除记录
     *
     * @param SysInterfaceParam 待删除的记录
     * @return 返回影响行数
     */
	int delete(SysInterfaceParam sysInterfaceParam);

    List<SysInterfaceParam> getByInterfaceId(@Param("interfaceId") String interfaceId);

	int deleteByInterfaceId(@Param("interfaceId") String interfaceId);

	int insertBatch(@Param("paramList") List<SysInterfaceParam> paramList);
}